/*
 *    tube64 - a simple demonstration program
 *
 *			by Sebastian Mihai, 2015
 *          http://sebastianmihai.com
 */

#include <stdlib.h>
#include <time.h>
#include <conio.h>
#include <tgi.h>

#define SCREEN_X        (tgi_getxres())
#define SCREEN_Y        (tgi_getyres())
#define RADIUS 20

/* Workaround missing clock stuff */
#ifdef __APPLE2__
#  define clock()       0
#  define CLK_TCK       1
#endif

/* Use dynamically loaded driver by default */
#ifndef DYN_DRV
#  define DYN_DRV       1
#endif

/* Use static local variables for speed */
#pragma static-locals (1);

void init() {
    clrscr ();

#if DYN_DRV
    /* Load the graphics driver */
    cprintf ("initializing... mompls\r\n");
    tgi_load_driver (tgi_stddrv);
#else
    /* Install the graphics driver */
    tgi_install (tgi_static_stddrv);
#endif

    /* Initialize graphics */
    tgi_init ();
    tgi_clear ();
}

int main() {
	int centreX, centreY;
	int dx, dy;
	
	init();
	
	centreX = SCREEN_X / 2 - RADIUS / 2;
	centreY = SCREEN_Y / 2 - RADIUS / 2;
	dx = -1;
	dy = -1;
	
	while(1) {
		tgi_circle( centreX, centreY, RADIUS );
		
		if( centreX + dx >= SCREEN_X - RADIUS ) {
			dx = -1 * dx;
		}
		if( centreY + dy >= SCREEN_Y - RADIUS ) {
			dy = -1 * dy;
		}
		if( centreX + dx <= RADIUS ) {
			dx = -1 * dx;
		}
		if( centreY + dy <= RADIUS ) {
			dy = -1 * dy;
		}
			
		centreX += dx;
		centreY += dy;
	}
	
    return EXIT_SUCCESS;
}
